/* 1541control - way overdesigned LCD addon for a 1541
   Copyright (C) 2007  Ingo Korb <ingo@akana.de>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License only.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   
   encoder.h: Rotary encoder status (and timekeeping)

*/

#ifndef ENCODER_H
#define ENCODER_H

#include <stdint.h>
#include <avr/pgmspace.h>

void init_encoder(void);

//typedef uint32_t jiffy_t;
typedef uint16_t jiffy_t;

/* see linux 2.6 include/linux/jiffies.h for details */
#define time_after(a,b)		\
	 ((int16_t)(b) - (int16_t)(a) < 0)
#define time_before(a,b)	time_after(b,a)

extern volatile int8_t   encoder_position;
extern volatile jiffy_t  jiffies;
extern volatile jiffy_t  last_encoder_change;
extern volatile uint8_t  key_state;
extern volatile jiffy_t  last_key_change;

#endif
