/* 1541control - way overdesigned LCD addon for a 1541
   Copyright (C) 2007  Ingo Korb <ingo@akana.de>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License only.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   
   uart.c: Serial port handling

*/

#include "config.h"
#include <avr/io.h>
#include <stdio.h>

int uart_putc(char c, FILE *stream) {
  if (c == '\n') uart_putc('\r', stream);
  loop_until_bit_is_set(UCSRA,UDRE);
  UDR = c;
  return 0;
}

char uart_getc(void) {
  loop_until_bit_is_set(UCSRA,RXC);
  return UDR;
}

static FILE mystderr = FDEV_SETUP_STREAM(uart_putc, NULL, _FDEV_SETUP_WRITE);

void init_serial(void) {
  /* Seriellen Port konfigurieren */
  UBRRH = (F_CPU/(16L*BAUDRATE)-1) >> 8;
  UBRRL = (F_CPU/(16L*BAUDRATE)-1) & 0xff;
  UCSRB = _BV(RXEN) | _BV(TXEN);
  UCSRC = _BV(URSEL) | _BV(UCSZ1) | _BV(UCSZ0);
  stderr = &mystderr;
}
